class Enemy {
	char	m_name[32];	//[U[
	int		m_nowHP;	//݂̗̑
	int		m_maxHP;	//ő̗
	int		m_atk;		//őU
	int		m_def;		//őh
	int		m_recovery;	//ő񕜒l
	int		m_exp;		//݂̌ol
	int		m_money;	//

public:
	Enemy() {					//eϐiRXgN^j
		strcpy(m_name, "");
		m_nowHP = m_maxHP = m_atk = m_def = m_recovery = m_exp = m_money = 0;
	}
	void Create(User);			//GL쐬			F[U[̃NX
	void BossCreate(User);		//{XL쐬		F[U[̃NX
	void ShowInfo();			//[U[\ifobOpj
	int  GetInfo(int kindInfo);	//G擾			F擾
	char *GetName();			//G̖O擾
	void Recovery(int num);		//̗͉
	int  Damage(int num);		//̗͌				F̗́i_[Wj
	void Escape();
};

void Enemy::Create(User user) {
	char buf[32] = "";

	for (int i = 0; i < rand()%20 + 10; i++) {
		buf[i] = (char)(rand()%25 + 97);
	}

	strcpy(m_name, buf);

	m_nowHP = m_maxHP = (strlen(m_name) * 3 * (int)((double)user.GetInfo(LEVEL) * 0.5 + 0.5) < 30 ? 30 : strlen(m_name) * 3);
	m_atk = strlen(m_name) * 4 * (int)((double)user.GetInfo(LEVEL) * 0.5 + 0.5) + (rand() % 30 - 15);
	m_def = strlen(m_name) * 4 * (int)((double)user.GetInfo(LEVEL) * 0.5 + 0.5) + (rand() % 30 - 15);
	m_money = rand() % (m_nowHP - 20) * (int)((double)user.GetInfo(LEVEL) * 0.5 + 0.5) + 20;
	m_exp = rand() % (m_nowHP - 20) * (int)((double)user.GetInfo(LEVEL) * 0.5 + 0.5) + 20;
}

void Enemy::BossCreate(User user) {
	char buf[64] = "";

	for (int i = 0; i < rand()%52 + 10; i++) {
		buf[i] = (char)(rand()%25 + 97);
	}

	strcpy(m_name, buf);

	m_nowHP = m_maxHP = (strlen(m_name) * 3 * (int)((double)user.GetInfo(LEVEL) * 1.5 + 0.5) < 30 ? 30 : strlen(m_name) * 3);
	m_atk = strlen(m_name) * 4 * (int)((double)user.GetInfo(LEVEL) * 1.5 + 0.5) + (rand() % 30 - 15);
	m_def = strlen(m_name) * 4 * (int)((double)user.GetInfo(LEVEL) * 1.5 + 0.5) + (rand() % 30 - 15);
	m_money = rand() % (m_nowHP - 20 * (int)((double)user.GetInfo(LEVEL) * 1.5 + 0.5)) + 20 * (int)((double)user.GetInfo(LEVEL) * 1.5);
	m_exp = rand() % (m_nowHP - 20 * (int)((double)user.GetInfo(LEVEL) * 1.5 + 0.5)) + 20 * (int)((double)user.GetInfo(LEVEL) * 1.5);
}

void Enemy::ShowInfo() {
	printf("LF%15s ̗ F%5d@ÚF%5d@h́F%5d@F%6d@olF%5d\n\n",
		   m_name, m_nowHP, m_atk, m_def, m_money, m_exp);
}

int Enemy::GetInfo(int kindInfo) {
	switch (kindInfo) {
		case NOWHP:
			return m_nowHP;
		case ATK:
			return m_atk;
		case DEF:
			return m_def;
		case RECOVERY:
			return m_recovery;
		case EXP:
			return m_exp;
		case MONEY:
			return m_money;
		default:
			return -1;
	}
}

char *Enemy::GetName() {
	return m_name;
}

void Enemy::Recovery(int num) {
	m_nowHP += num;
	return;
}

int Enemy::Damage(int num) {
	if (m_nowHP <= num) {
		m_nowHP = 0;
	} else {
		m_nowHP -= num;
	}
	return num;
}